models/BookingType.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "booking_type".
 *
 * @property int $id
 * @property string|null $name
 *
 * @property EmployeeSeat[] $employeeSeats
 */
class BookingType extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'booking_type';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name'], 'string', 'max' => 50],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id'   => 'ID',
            'name' => 'Name',
        ];
    }

    /**
     * Gets query for [[EmployeeSeats]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getEmployeeSeats()
    {
        return $this->hasMany(EmployeeSeat::class, ['booking_type_id' => 'id']);
    }
}

controllers/BookingController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Office;
use app\search\OfficeSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use app\models\Seat;
use app\forms\SeatBookingForm;
use yii\web\Response;

class BookingController extends Controller
{
    /**
     * Lists all Office models.
     * @return mixed
     */
    public function actionIndex(): string
    {
        $searchModel = new OfficeSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', compact('dataProvider'));
    }

    /**
     * @param integer $id Office ID
     */
    public function actionOfficeSeats(int $id): string
    {
        $office = $this->findModel($id);

        return $this->render('officeSeats', compact('office'));
    }

    /**
     * @param integer $id Seat ID
     * 
     * @return yii\web\Response
     */
    public function actionBookSeat(int $id): Response
    {
        $seat = Seat::findOne($id);
        if (!$seat) {
            throw new NotFoundHttpException('The requested record does not exist.');
        }
        $model = new SeatBookingForm($seat);

        if ($model->load(\Yii::$app->request->post()) && $model->validate()) {
            $success = $model->bookSeat();

            if (!$success) {
                Yii::$app->session->setFlash('error_booking', "There was an error trying to book one or more of the selected hours.");
            }
        }
        return $this->asJson([
            'html' => $this->renderPartial('_hours', compact('model'))
        ]);
    }

    /**
     * Finds the Office model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Office the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel(int $id): Office
    {
        if (($model = Office::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

views/booking/_hours.php
<?php

use yii\helpers\Html;
use app\businesslayer\EmployeeBL;
use yii\helpers\ArrayHelper;
use yii\helpers\Url;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $seat app\businesslayer\SeatBL */
/* @var $model app\forms\SeatBookingForm */

$labelOptionsAvailable = ['class' => 'btn btn-info'];
$labelOptionsTaken = ['class' => 'btn btn-warning disabled'];

if (\Yii::$app->session->hasFlash('error_booking')) { ?>
    <div class="alert alert-warning">
        <?= Yii::$app->session->getFlash('error_booking'); ?>
    </div>
<?php }

$form = ActiveForm::begin([
    'id'      => "form-seat-{$model->seat->id}",
    'action'  => Url::to(['book-seat', 'id' => $model->seat->id]),
]);
?>
<div class="panel-body">
    <div class="row form-group">
        <?php
        echo $form->field($model, 'employeeId')->dropDownList(ArrayHelper::map(EmployeeBL::find()->all(), 'id', 'fullName'), [
            'prompt' => 'Select Employee',
            'class'  => 'employee-dropdown form-control'
        ])->label(false);

        echo $form->field($model, 'selectedHours', [
            'options' => ['class' => 'hours-checkboxlist']
        ])->checkboxList($model->hours, ['item' => function ($index, $label, $name, $checked, $value) use ($labelOptionsTaken, $labelOptionsAvailable) {
            $taken = $label === 'taken';
            return Html::checkbox($name, $checked, [
                'value'        => $value,
                'disabled'     => $taken ? true : false,
                'label'        => $value,
                'labelOptions' => $taken ? $labelOptionsTaken : $labelOptionsAvailable,
            ]);
        }])->label(false);

        echo $form->field($model, 'workDay')->checkbox([
            'class'        => 'work-day-checkbox',
            'label'        => 'All Day',
            'disabled'     => in_array('taken', $model->hours) ? true : false,
            'labelOptions' => in_array('taken', $model->hours) ? $labelOptionsTaken : $labelOptionsAvailable
        ])->label(false);
        ?>
    </div>
    <div class="row">
        <?= Html::button('Book', ['class' => 'btn-book-seat btn btn-primary']); ?>
    </div>
</div>
<?php
ActiveForm::end();

views/booking/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use app\models\Office;
use yii\grid\ActionColumn;
use yii\helpers\Url;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Offices';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="office-index">
    <h1><?= Html::encode($this->title) ?></h1>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            'name',
            [
                'class'     => ActionColumn::class,
                'template'  => '{book}',
                'buttons'   => [
                    'book' => function (string $url, Office $model) {
                        $icon = Html::tag('span', '', ['class' => "glyphicon glyphicon-calendar"]);

                        return Html::a($icon, Url::to(['booking/office-seats', 'id' => $model->id]), [
                            'title' => 'Book a seat',
                        ]);
                    },
                ],
            ],
        ],
    ]); ?>
</div>

views/booking/officeSeats.php
<?php

use yii\helpers\Html;
use app\assets\BookSeatAsset;
use app\forms\SeatBookingForm;

/* @var $this yii\web\View */
/* @var $office app\businesslayer\OfficeBL */

BookSeatAsset::register($this);

$this->title = "{$office->name} seats";
$this->params['breadcrumbs'][] = ['label' => 'Offices', 'url' => ['booking/index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="office-seats">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php foreach ($office->seats as $seat) : ?>
        <div class="col-xs-6">
            <div class="panel panel-info">
                <div class="panel-heading">
                    <strong>Seat <?= $seat->name ?></strong>
                </div>

                <?= $this->render('_hours', ['model' => new SeatBookingForm($seat)]) ?>

            </div>
        </div>
    <?php endforeach; ?>
</div>